#include <iostream>
#include <cmath>
using namespace std;
int main()
{
    int N,M,C,i,j;
    long long int x=0;
    cin >> N;
    cin >> M;
    int A[N+1],B[M+1];
    for(i=1;i<=M;i++)
        cin >> B[i];
    cin >> C;
    for(i=1;i<=N;i++)
        A[i]=i;
    for(i=0;i<=N-M;i++){
        for(int j=1;j<=M;j++)
            A[i+B[j]]=A[i+j];}
    for(i=1;i<=N;i++)
    {
        x+=pow(C,i)*A[i];
        x=x%998244353;
    }
    cout << x;
    return 0;
}